package examples.visitor.aspectj;

/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the design patterns project at UBC
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http:*www.mozilla.org/MPL/ or http:*aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is ca.ubc.cs.spl.pattern.
 *
 * Contributor(s):   
 */

import ca.ubc.cs.spl.pattern.library.VisitorProtocol;

/**
 * Implements a concrete visitor pattern instance. This aspect assings
 * the roles to the participants.
 *
 * @author  Jan Hannemann
 * @author  Gregor Kiczales
 * @version 1.0, 06/13/02
 */

public aspect MyVisitor extends VisitorProtocol { 
    
    /** 
     * Assigns the <code>VisitorNode</code> role to <code>Node</code>
     */

    declare parents: Node implements VisitorNode;

    /** 
     * Assigns the <code>VRegularNode</code> role to <code>RegularNode</code>
     */

    declare parents: RegularNode implements VRegularNode;

    /** 
     * Assigns the <code>VLeaf</code> role to <code>Leaf</code>
     */

    declare parents: Leaf implements VLeaf;
}
